using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class BossGiantAttack : StateMachineBehaviour
{
    private int giantDmgAbility = 100;
    private float giantDmgAtk = 100f;

    private float timer;
    private float timeBeforeActualHit = 1f;

    private BossGiant bossInstance;
    //OnStateEnter is called when a transition starts and the state machine starts to evaluate this state
    override public void OnStateEnter(Animator animator, AnimatorStateInfo stateInfo, int layerIndex)
    {
        timer = 0f;

        bossInstance = animator.GetComponent<BossGiant>();
        bossInstance.phase1ColliderAndParticleSys.Play();
    }

    //OnStateUpdate is called on each Update frame between OnStateEnter and OnStateExit callbacks
    override public void OnStateUpdate(Animator animator, AnimatorStateInfo stateInfo, int layerIndex)
    {
        timer += Time.deltaTime;
        if(timer > timeBeforeActualHit)
        {
            timer = 0f;
            Vector3 collisionCenter = bossInstance.phase1ColliderAndParticleSys.transform.position;
            float collisionRadius = bossInstance.phase1ColliderAndParticleSys.GetComponent<SphereCollider>().radius;
            LayerMask playerLayer = LayerMask.GetMask("players");
            Collider[] hitPlayers = Physics.OverlapSphere(collisionCenter, collisionRadius, playerLayer);

            foreach (Collider hitPlayer in hitPlayers)
            {
                if (hitPlayer.gameObject.GetComponent<Players>() == null)
                {
                    hitPlayer.gameObject.GetComponentInParent<Players>().TakeDamage(giantDmgAbility, giantDmgAtk);
                }
                else
                {
                    hitPlayer.gameObject.GetComponent<Players>().TakeDamage(giantDmgAbility, giantDmgAtk);
                }
            }
            // test for collision fron sphere collider
            // send particles and dont forget to add script to gameobject so particles can deal dmg

            animator.SetBool("IsAttacking", false);
            animator.SetBool("IsChasing", false);
        }
    }

    //OnStateExit is called when a transition ends and the state machine finishes evaluating this state
    override public void OnStateExit(Animator animator, AnimatorStateInfo stateInfo, int layerIndex)
    {

    }

    // OnStateMove is called right after Animator.OnAnimatorMove()
    //override public void OnStateMove(Animator animator, AnimatorStateInfo stateInfo, int layerIndex)
    //{
    //    // Implement code that processes and affects root motion
    //}

    // OnStateIK is called right after Animator.OnAnimatorIK()
    //override public void OnStateIK(Animator animator, AnimatorStateInfo stateInfo, int layerIndex)
    //{
    //    // Implement code that sets up animation IK (inverse kinematics)
    //}
}
