using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossSlimeCollisionDetection : MonoBehaviour
{
    private int slimeDmgAbility = 70;
    private float slimeDmgAtk = 150f;
    private BossSlime bossInstance;

    private void Awake()
    {
        bossInstance = GetComponentInParent<BossSlime>();
    }

    private void OnTriggerEnter(Collider other)
    {
        if(bossInstance.canDealDamage)
        {
            if (other.gameObject.layer == LayerMask.NameToLayer("players"))
            {
                other.gameObject.GetComponent<Players>().TakeDamage(slimeDmgAbility, slimeDmgAtk);
            }
        }
    }

    private void OnCollisionEnter(Collision collision)
    {
        if(bossInstance.canDealDamage)
        {
            if (collision.gameObject.layer == LayerMask.NameToLayer("players"))
            {
                collision.gameObject.GetComponent<Players>().TakeDamage(slimeDmgAbility, slimeDmgAtk);
            }
        }
    }
}
