using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BossSlimeFireZone : MonoBehaviour
{
    private float fireMaxLifetime = 5f;
    private float fireDmgCooldown = 1f;
    private int fireDmgAbility = 25;
    private float fireDmgAtk = 75f;

    private Collider fireCollider;

    private float timer;
    private float colliderTimer;
    // Start is called before the first frame update
    void Start()
    {
        fireCollider = GetComponent<Collider>();
        timer = colliderTimer = 0f;
    }

    // Update is called once per frame
    void Update()
    {
        timer += Time.deltaTime;
        if(timer >= fireMaxLifetime)
        {
            Object.Destroy(this.gameObject);
        }

        colliderTimer += Time.deltaTime;
    }

    private void OnTriggerEnter(Collider other)
    {
        if (colliderTimer > fireDmgCooldown)
        {
            if (other.gameObject.layer == LayerMask.NameToLayer("players"))
            {
                other.gameObject.GetComponent<Players>().TakeDamage(fireDmgAbility, fireDmgAtk);
                colliderTimer = 0f;
            }
        }
    }
}
