using System.Collections;
using System.Collections.Generic;
using Script.Statistics;
using TMPro;
using Unity.VisualScripting;
using UnityEngine;
using UnityEngine.InputSystem;
using UnityEngine.UI;
public class RangeMinion : Enemy
{
    public List<string> animations;

    public GameObject projectilePrefab;
    private int nbAttacks = 0;

    public void FixedUpdate()
    {
        // attaque lorsqu'il détecte des joueurs dans sa portée d'attaque
        if(GetComponent<ScriptPathfindingEnnemy>().playerDetected && Vector3.Distance(GetComponent<ScriptPathfindingEnnemy>().target[0].transform.position, gameObject.transform.position) < 15)
            StartCoroutine(Attack());

    }
    public override void EnemyInit()
    {
        stats = ScriptableObject.CreateInstance<RangeMinionStatistics>();
        stats.init();
        healthBar.GetComponent<Slider>().maxValue = stats.maxHp;
        healthBar.GetComponent<Slider>().value = stats.currentHp;
        coolDown = 50f;
        attackAvailable = true;
    }

    public override IEnumerator Attack()
    {
        if (!attackAvailable)
        {
            yield break;
        }
        // Déclenche l'animation d'attaque
        animator.SetTrigger("AutoAttacking");
        StartCoroutine(StartCoolDown(stats.attackSpeed, 1));

        GameObject projectile = Instantiate(projectilePrefab, prefabSpawnPoint.position, prefabSpawnPoint.rotation);
        
        Vector3 direction = (-transform.position + GetComponent<ScriptPathfindingEnnemy>().target[0].transform.position).normalized;
        projectile.GetComponent<Rigidbody>().AddForce(direction * ((RangeMinionStatistics)stats).arrowSpeed );
        //ignore la collision avec l'archer
        Physics.IgnoreCollision(projectile.GetComponent<Collider>(), GetComponent<Collider>());

        //projectile.GetComponent<Rigidbody>().velocity = ((EnemyStatistics)stats).arrowSpeed * prefabSpawnPoint.forward;

    }

    public override IEnumerator StartCoolDown(float coolDown, int idAttack)
    {
        attackAvailable = false;
        yield return new WaitForSeconds(coolDown);
        attackAvailable = true;
    }

    private void KnockBacking(Collider enemy)
    {
        Rigidbody enemyRB = enemy.GetComponent<Rigidbody>();
        //enemyRB.isKinematic = false;
        Vector3 difference = enemyRB.transform.position - transform.position;
        difference = difference.normalized * stats.thrust;
        enemyRB.AddForce(difference, ForceMode.Impulse);
        StartCoroutine(KnockCo(enemyRB));
    }
    private IEnumerator KnockCo(Rigidbody enemy)
    {
        if (enemy != null)
        {
            yield return new WaitForSeconds(stats.knockTime);
            if(enemy != null)
                enemy.velocity = Vector3.zero;
            //enemy.isKinematic = true;
        }
    }
}
