using System;
using System.Collections.Generic;
using System.Collections;
using Cinemachine;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.AI;
using UnityEngine.Rendering;
using UnityEngine.InputSystem;
using UnityEngine.UI;
using UnityEngine.Events;
using Newtonsoft.Json;

public class ScriptGenerationDonjon : MonoBehaviour
{
    public GameObject startingRoom1;
    private float nextActionTime;
    private bool hasChangedRoom = true;
    public float period = 5f;
    public GameObject startingRoom2;
    public GameObject startingRoom2Bis;
    public GameObject startingRoom3;
    public GameObject startingRoom4;
    public GameObject room4Entrances;
    public GameObject chestModel;
    public GameObject closedChestModel;
    public GameObject prefabBossRoom;
    private GameObject player;

    public GameObject prefabBossGiant;
    public GameObject prefabMerchantRoom;

    private GameObject currentRoom;

    private List<node> list;
    //liste des brouillard mise à jour à chaque changement de salle
    private List<GameObject> listFogs = new List<GameObject>();

    private int nbRoomOnePath = 0;
    public GameObject prefabLadder;
    static public int maxRoom = 12;

    static public int floor = 1;

    private Location[,] array;
    static private int endFloor = 3;

    public static int numberEnemyRemainingInRoom = 0;

    public static System.Random randomPersonal = new System.Random();

    // Music
    public AudioSource audioSrcCombat;
    public AudioSource audioSrcNonCombat;

    public List<GameObject> listEnnemy;


    [Header("Events")]
    // Event pour informer de la fin du jeu
    public UnityEvent onEnd;

    public struct node
    {
        public int x;
        public int y;

        public node(int x, int y)
        {
            this.x = x;
            this.y = y;
        }
    }


    public struct SpecialRoomOneEntry
    {
        public int i;
        public int j;

        public int orientation;
        public GameObject room;

        public SpecialRoomOneEntry(int i, int j, int orientation, GameObject room)
        {
            this.i = i;
            this.j = j;
            this.room = room;
            this.orientation = orientation;
        }
    }

    // Structure de donnée désignant un emplacement de salle dans le donjon
    public struct Location
    {
        public int orientation; // 0 Bottom 1 LEFT 2 TOP 3 RIGHT
        public int value; //0 si il n'y a pas de salle à cet emplacement 1 sinon

        public int isShop;

        public int isBoss;

        public Location(int orientation, int value)
        {
            this.orientation = orientation;
            this.value = value;
            this.isBoss = 0;
            this.isShop = 0;
        }
        public Location(int orientation, int value, int isShop, int isBoss)
        {
            this.orientation = orientation;
            this.value = value;
            this.isBoss = isBoss;
            this.isShop = isShop;
        }
    }

    // Génération d'un tableau 2D d'emplacements
    Location[,] GenerationArrayRoom(int sizeX, int sizeY, int maxRoom)
    {
        List<node> list = new List<node>();
        array = new Location[sizeX, sizeY];
        for (int i = 0; i < sizeX; i++)
            for (int j = 0; j < sizeY; j++)
                array[i, j] = new Location(0, 0);

        array[sizeX / 2, sizeY / 2] = new Location(0, 1);
        node startingNode = new node(sizeX / 2, sizeY / 2);

        list.Add(startingNode);

        int nbRoom = 1;

        int index = 0;

        // Tant qu'il reste des salles à poser, on essaie d'en poser en cyclant sur toutes les salles disponibles (si list[index] == list.Length, on la recommence à 0)
        while (nbRoom < maxRoom)
        {
            if (index == list.Count)
                index = 0;

            if (CheckMustGenerateRoom(nbRoom, list[index].x + 1, list[index].y, sizeX, sizeY, array, maxRoom))
            {
                Location newRoom = new Location(3, 1);
                array[list[index].x + 1, list[index].y] = newRoom;
                node newNode = new node(list[index].x + 1, list[index].y);
                list.Add(newNode);
                nbRoom++;
            }

            else if (CheckMustGenerateRoom(nbRoom, list[index].x, list[index].y + 1, sizeX, sizeY, array, maxRoom))
            {
                Location newRoom = new Location(2, 1);
                array[list[index].x, list[index].y + 1] = newRoom;
                node newNode = new node(list[index].x, list[index].y + 1);
                list.Add(newNode);
                nbRoom++;
            }

            else if (CheckMustGenerateRoom(nbRoom, list[index].x, list[index].y - 1, sizeX, sizeY, array, maxRoom))
            {
                Location newRoom = new Location(0, 1);
                array[list[index].x, list[index].y - 1] = newRoom;
                node newNode = new node(list[index].x, list[index].y - 1);
                list.Add(newNode);
                nbRoom++;
            }

            else if (CheckMustGenerateRoom(nbRoom, list[index].x - 1, list[index].y, sizeX, sizeY, array, maxRoom))
            {
                Location newRoom = new Location(1, 1);
                array[list[index].x - 1, list[index].y] = newRoom;
                node newNode = new node(list[index].x - 1, list[index].y);
                list.Add(newNode);
                nbRoom++;
            }

            index++;
        }
        return array;

    }

    //Vérification de la validité d'un emplacement pour savoir si elle est éligible à être une salle
    bool CheckMustGenerateRoom(int nbRoom, int nX, int nY, int sizeX, int sizeY, Location[,] array, int maxRoom)
    {
        if (nbRoom >= maxRoom)
            return false;
        if (nX < 0 || nX >= sizeX || nY < 0 || nY >= sizeY)
            return false;

        if (array[nX, nY].value == 1)
            return false;

        int neighbor = 0;

        if ((nX + 1) >= 0 && (nX + 1) < sizeX)
            neighbor += array[nX + 1, nY].value;
        if ((nX - 1) >= 0 && (nX - 1) < sizeX)
            neighbor += array[nX - 1, nY].value;
        if ((nY + 1) >= 0 && (nY + 1) < sizeY)
            neighbor += array[nX, nY + 1].value;
        if ((nY - 1) >= 0 && (nY - 1) < sizeY)
            neighbor += array[nX, nY - 1].value;

        if (neighbor > 1)
            return false;

        if (UnityEngine.Random.Range(0, 2) == 0)
            return false;
        return true;
    }

    int CountNeighbor(Location[,] array, int x, int y, int sizeX, int sizeY)
    {
        int count = 0;
        if (x + 1 < sizeX && array[x + 1, y].value == 1)
            count++;
        if (x - 1 >= 0 && array[x - 1, y].value == 1)
            count++;
        if (y + 1 < sizeY && array[x, y + 1].value == 1)
            count++;
        if (y - 1 >= 0 && array[x, y - 1].value == 1)
            count++;

        return count;
    }

    //Vérifie si un emplacement est une salle ou non
    bool CheckNeighbors(Location[,] array, int x, int y, int sizeX, int sizeY)
    {
        if (x < sizeX && y < sizeY && x >= 0 && y >= 0 && array[x, y].value == 1)
            return true;
        return false;
    }

    List<Transform> GetAllChild(Transform transform)
    {
        List<Transform> list = new List<Transform>();
        for (int i = 0; i < transform.childCount; i++)
            list.Add(transform.GetChild(i));
        return list;
    }

    // Génère les ennemis et les coffres dans une salle donnée
    void GenerateAssets(GameObject room, int min_ennemy, int max_ennemy)
    {


        //Ici on regarde si on veut créer un coffre dans la salle room
        if (UnityEngine.Random.Range(0f, 1f) > 0.2f)
        {
            if (UnityEngine.Random.Range(0f, 1f) > 0.3f)
            {
                Transform placeholderSpawnerChest = room.transform.Find("PlaceHolderSpawnerChest");
                GameObject newChest = Instantiate(chestModel, new Vector3(placeholderSpawnerChest.position.x, 0.5f, placeholderSpawnerChest.position.z), Quaternion.identity);
                newChest.transform.parent = room.transform;
            }
            else
            {
                Transform placeholderSpawnerChest = room.transform.Find("PlaceHolderSpawnerChest");
                GameObject newChest = Instantiate(closedChestModel, new Vector3(placeholderSpawnerChest.position.x, 0.5f, placeholderSpawnerChest.position.z), Quaternion.identity);
                newChest.transform.parent = room.transform;
            }

        }


        if (Lobby.isMainPlayer)
        {
            EnemySend.shouldJoinLobby = true;

            Transform placeholderSpawner = room.transform.Find("PlaceHolderSpawnerEnnemies");
            if (placeholderSpawner != null)
            {
                int num_ennemy = randomPersonal.Next(min_ennemy, max_ennemy + 1);
                List<Transform> allPlaceholderEnnemy = GetAllChild(placeholderSpawner);
                for (int i = 0; i < num_ennemy; i++)
                {
                    int indexNewEnnemy = randomPersonal.Next(0, allPlaceholderEnnemy.Count);
                    GameObject ennemyPrefab = listEnnemy[randomPersonal.Next(0, listEnnemy.Count)];
                    GameObject newEnnemy = Instantiate(ennemyPrefab, allPlaceholderEnnemy[indexNewEnnemy].position, Quaternion.identity);
                    newEnnemy.GetComponent<Enemy>().currentRoom = currentRoom;
                    newEnnemy.name = "enemy" + Lobby.roomCode + (i + 1); // -----------------------------------------------------------------------------------------------------------------------------------------
                    allPlaceholderEnnemy.RemoveAt(indexNewEnnemy);
                    newEnnemy.transform.parent = room.transform;
                }
            }
        }

        //On build le navmesh pour que les ennemis puissent se déplacer vers le joueur
        room.GetComponent<NavMeshSurface>().BuildNavMesh();

        //On compte le nombre d'ennemi pour savoir combien il faut en tuer pour ouvrir la salle
        InitNumberEnemy();
        GameObject.FindObjectOfType<Minimap>().refreshMinimap();
    }


    // Fonction principale de la génération du donjon
    GameObject StartGenerationDungeon(int maxRoom)
    {
        GameObject bossRoom = new GameObject();
        GameObject shopRoom = new GameObject();
        GameObject startingRoom = new GameObject();
        bool isStartingRoomOneEntry = false;
        int sizeX = 8;
        int sizeY = 8;
        int distance = 45;
        List<SpecialRoomOneEntry> listOneEntry = new List<SpecialRoomOneEntry>();

        Location[,] array = GenerationArrayRoom(sizeX, sizeY, maxRoom);

        for (int i = 0; i < sizeX; i++)
            for (int j = 0; j < sizeY; j++)
            {
                if (array[i, j].value == 1)
                {
                    int count = CountNeighbor(array, i, j, sizeX, sizeY);

                    // Génération d'une salle à 4 entrées
                    if (count == 4)
                    {
                        GameObject newRoom;
                        if (i == sizeX / 2 && j == sizeY / 2)
                        {
                            newRoom = Instantiate(startingRoom4, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                            startingRoom = newRoom;
                        }
                        else
                            newRoom = Instantiate(room4Entrances, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                    }

                    // Génération d'une salle à 3 entrées
                    else if (count == 3)
                    {
                        // On récupère une salle à 3 entrées aléatoire parmi celle créee
                        GameObject[] asset3Entries = Resources.LoadAll<GameObject>("Room/Room3");
                        GameObject room3 = asset3Entries[UnityEngine.Random.Range(0, asset3Entries.Length)];
                        GameObject newRoom;

                        //Si on est au milieu du tableau on veut créer une salle de départ plutôt qu'une salle normale
                        if (i == sizeX / 2 && j == sizeY / 2)
                        {
                            newRoom = Instantiate(startingRoom3, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                            startingRoom = newRoom;
                        }
                        else
                            newRoom = Instantiate(room3, new Vector3(i * distance, 1, j * distance), Quaternion.identity);

                        //Ajustement de la rotation de la salle en fonction des voisins
                        var rot = newRoom.transform.localRotation.eulerAngles; //get the angles
                        if (CheckNeighbors(array, i, j + 1, sizeX, sizeY) && CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i - 1, j, sizeX, sizeY))
                            rot.Set(0f, 90f, 0f);


                        else if (CheckNeighbors(array, i, j - 1, sizeX, sizeY) && CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i - 1, j, sizeX, sizeY))
                            rot.Set(0f, -90f, 0f);


                        else if (CheckNeighbors(array, i, j - 1, sizeX, sizeY) && CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i, j + 1, sizeX, sizeY))
                            rot.Set(0f, -180f, 0f);

                        newRoom.transform.localRotation = Quaternion.Euler(rot);
                    }

                    // Génération d'une salle à 2 entrées
                    else if (count == 2)
                    {
                        // Il y a deux types de salles à 2 entrées: les salles où les entrées sont face à face
                        // et les salles coudées. On génère la bonne salle et on l'oriente en fonction des voisins

                        if (CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i - 1, j, sizeX, sizeY))
                        {
                            // On récupère une salle à 2 entrées aléatoire parmi celle créee
                            GameObject[] asset2Entries = Resources.LoadAll<GameObject>("Room/Room2");
                            GameObject room2 = asset2Entries[UnityEngine.Random.Range(0, asset2Entries.Length)];
                            GameObject newRoom;

                            //Si on est au milieu du tableau on veut créer une salle de départ plutôt qu'une salle normale
                            if (i == sizeX / 2 && j == sizeY / 2)
                            {
                                newRoom = Instantiate(startingRoom2, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                                startingRoom = newRoom;
                            }
                            else
                                newRoom = Instantiate(room2, new Vector3(i * distance, 1, j * distance), Quaternion.identity);


                            var rot = newRoom.transform.localRotation.eulerAngles;
                            rot.Set(0f, 90f, 0f);
                            newRoom.transform.localRotation = Quaternion.Euler(rot);

                        }
                        else if (CheckNeighbors(array, i, j - 1, sizeX, sizeY) && CheckNeighbors(array, i, j + 1, sizeX, sizeY))
                        {
                            GameObject[] asset2Entries = Resources.LoadAll<GameObject>("Room/Room2");
                            GameObject room2 = asset2Entries[UnityEngine.Random.Range(0, asset2Entries.Length)];
                            GameObject newRoom;

                            //Si on est au milieu du tableau on veut créer une salle de départ plutôt qu'une salle normale
                            if (i == sizeX / 2 && j == sizeY / 2)
                            {
                                newRoom = Instantiate(startingRoom2, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                                startingRoom = newRoom;
                            }
                            else
                                newRoom = Instantiate(room2, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                        }
                        else
                        {
                            // On récupère une salle à 2 entrées aléatoire parmi celle créee
                            GameObject[] asset2EntriesBis = Resources.LoadAll<GameObject>("Room/Room2Bis");
                            GameObject room2Bis = asset2EntriesBis[UnityEngine.Random.Range(0, asset2EntriesBis.Length)];
                            GameObject newRoom;

                            //Si on est au milieu du tableau on veut créer une salle de départ plutôt qu'une salle normale
                            if (i == sizeX / 2 && j == sizeY / 2)
                            {
                                newRoom = Instantiate(startingRoom2Bis, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                                startingRoom = newRoom;
                            }
                            else
                                newRoom = Instantiate(room2Bis, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                            var rot = newRoom.transform.localRotation.eulerAngles;

                            if (CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i, j - 1, sizeX, sizeY))
                                rot.Set(0f, 180f, 0f);


                            else if (CheckNeighbors(array, i + 1, j, sizeX, sizeY) && CheckNeighbors(array, i, j + 1, sizeX, sizeY))
                                rot.Set(0f, 90f, 0f);

                            else if (CheckNeighbors(array, i - 1, j, sizeX, sizeY) && CheckNeighbors(array, i, j - 1, sizeX, sizeY))
                                rot.Set(0f, -90f, 0f);

                            newRoom.transform.localRotation = Quaternion.Euler(rot);

                        }
                    }
                    // Génération d'une salle à 1 entrées
                    else if (count == 1)
                    {
                        nbRoomOnePath++;
                        // On récupère une salle à 1 entrée aléatoire parmi celle créee
                        GameObject[] asset1Entry = Resources.LoadAll<GameObject>("Room/Room1");
                        GameObject room1 = asset1Entry[UnityEngine.Random.Range(0, asset1Entry.Length)];
                        GameObject newRoom;
                        //Si on est au milieu du tableau on veut créer une salle de départ plutôt qu'une salle normale
                        if (i == sizeX / 2 && j == sizeY / 2)
                        {
                            isStartingRoomOneEntry = true;
                            newRoom = Instantiate(startingRoom1, new Vector3(i * distance, 1, j * distance), Quaternion.identity);
                        }
                        else
                            newRoom = Instantiate(room1, new Vector3(i * distance, 1, j * distance), Quaternion.identity);



                        var rot = newRoom.transform.localRotation.eulerAngles;
                        rot.Set(0f, 90f * array[i, j].orientation, 0f);
                        newRoom.transform.localRotation = Quaternion.Euler(rot);

                        SpecialRoomOneEntry newSpecialRoom = new SpecialRoomOneEntry(i, j, array[i, j].orientation, newRoom);
                        listOneEntry.Add(newSpecialRoom);

                        // Ca arrive des fois que la salle du boss soit la salle de départ
                        // Ce qui résulte en la suppression de la salle de départ et le personnage
                        // spawn en (0 0 0) du coup je garde toujours une autre salle à une entrée dans
                        // mes manches et quand la position finale de la salle du boss est décidée, je regarde
                        // si ce n'est pas la salle de départ sinon j'associe la salle du boss à l'avant dernière 
                        // salle à une entrée
                    }

                }

            }


        // On associe la salle de spawn si il doit y en avoir une, la salle du boss et la salle du marchand
        if (nbRoomOnePath == 2)
        {
            if (isStartingRoomOneEntry)
            {
                SpecialRoomOneEntry specialRoom = listOneEntry[0];
                Destroy(specialRoom.room);
                startingRoom = Instantiate(startingRoom1, new Vector3(specialRoom.i * distance, 1, specialRoom.j * distance), Quaternion.identity);
                var rotation_starting = startingRoom.transform.localRotation.eulerAngles;

                if (specialRoom.i + 1 < sizeX && array[specialRoom.i + 1, specialRoom.j].value == 1)
                {
                    rotation_starting.Set(0f, 90f, 0);
                }
                else if (specialRoom.i - 1 >= 0 && array[specialRoom.i - 1, specialRoom.j].value == 1)
                {
                    rotation_starting.Set(0f, -90f, 0);
                }
                else if (specialRoom.j + 1 < sizeY && array[specialRoom.i, specialRoom.j + 1].value == 1)
                {
                    rotation_starting.Set(0f, 0f, 0);
                }
                else if (specialRoom.j - 1 >= 0 && array[specialRoom.i, specialRoom.j - 1].value == 1)
                {
                    rotation_starting.Set(0f, 180, 0);
                }
                startingRoom.transform.localRotation = Quaternion.Euler(rotation_starting);
            }

            SpecialRoomOneEntry boss = listOneEntry[1];
            Destroy(boss.room);
            bossRoom = Instantiate(prefabBossRoom, new Vector3(boss.i * distance, 1, boss.j * distance), Quaternion.identity);
            var rotation_boss = bossRoom.transform.localRotation.eulerAngles;
            rotation_boss.Set(0f, 90f * boss.orientation, 0f);
            bossRoom.transform.localRotation = Quaternion.Euler(rotation_boss);
        }
        else
        {

            if (isStartingRoomOneEntry)
            {
                SpecialRoomOneEntry specialRoom = listOneEntry[listOneEntry.Count / 2];
                Destroy(specialRoom.room);
                startingRoom = Instantiate(startingRoom1, new Vector3(specialRoom.i * distance, 1, specialRoom.j * distance), Quaternion.identity);
                var rotation_starting = startingRoom.transform.localRotation.eulerAngles;

                if (specialRoom.i + 1 < sizeX && array[specialRoom.i + 1, specialRoom.j].value == 1)
                {
                    rotation_starting.Set(0f, 90f, 0);
                }
                else if (specialRoom.i - 1 >= 0 && array[specialRoom.i - 1, specialRoom.j].value == 1)
                {
                    rotation_starting.Set(0f, -90f, 0);
                }
                else if (specialRoom.j + 1 < sizeY && array[specialRoom.i, specialRoom.j + 1].value == 1)
                {
                    rotation_starting.Set(0f, 0f, 0);
                }
                else if (specialRoom.j - 1 >= 0 && array[specialRoom.i, specialRoom.j - 1].value == 1)
                {
                    rotation_starting.Set(0f, 180, 0);
                }
                startingRoom.transform.localRotation = Quaternion.Euler(rotation_starting);
            }

            SpecialRoomOneEntry boss = listOneEntry[listOneEntry.Count - 1];
            Destroy(boss.room);
            bossRoom = Instantiate(prefabBossRoom, new Vector3(boss.i * distance, 1, boss.j * distance), Quaternion.identity);
            var rotation_boss = bossRoom.transform.localRotation.eulerAngles;
            rotation_boss.Set(0f, 90f * boss.orientation, 0f);
            bossRoom.transform.localRotation = Quaternion.Euler(rotation_boss);


            // Un étage a une chance sur deux d'avoir un marchand
            if (UnityEngine.Random.Range(0, 100) > 30 && nbRoomOnePath != 2)
            {
                // Destruction de la salle qui sera remplacée par la salle du marchand
                SpecialRoomOneEntry merchant = listOneEntry[0];
                Destroy(merchant.room);
                GameObject merchantRoom = Instantiate(prefabMerchantRoom, new Vector3(merchant.i * distance, 1, merchant.j * distance), Quaternion.identity);
                var rotation_merchant = merchantRoom.transform.localRotation.eulerAngles;
                rotation_merchant.Set(0f, 90f * merchant.orientation, 0f);
                merchantRoom.transform.localRotation = Quaternion.Euler(rotation_merchant);
            }
        }
        return startingRoom;
    }

    public void EventChangeFloor()
    {
        maxRoom += 2;
        ChangeFloor(maxRoom);
    }

    void ChangeFloor(int maxRoom)
    {
        floor++;
        Debug.Log("floor: " + floor);

        // Déclanche l'event onEnd
        if (floor == endFloor)
        {
            if (Lobby.isMainPlayer)
            {
                Lobby.infoSendSimple.currentScene = "EndScene";
                Lobby.socket.SendAsync(JsonConvert.SerializeObject(Lobby.infoSendSimple));
            }

            Players[] players = GameObject.FindObjectsOfType<Players>();
            if(players != null)
                for(int i = 0; i < players.Length; i++)
                    players[i].inEndGame = true;

            onEnd?.Invoke();
        }

        else if (floor == 2)
            SceneManager.LoadScene("Floor2");
    }

    public void OpenRoom(GameObject room)
    {
        Transform wallOpening = room.transform.Find("wall_opening");
        foreach (Transform child in wallOpening)
        {
            child.GetComponent<Renderer>().enabled = false;
            child.GetComponent<BoxCollider>().enabled = false;
        }
    }

    public void CloseRoom(GameObject room)
    {
        Transform wallOpening = room.transform.Find("wall_opening");
        wallOpening.gameObject.tag = "obstacle";
        wallOpening.gameObject.layer = LayerMask.NameToLayer("chest");
        if (wallOpening == null)
            return;
        foreach (Transform child in wallOpening)
        {
            child.GetComponent<Renderer>().enabled = true;
            child.GetComponent<BoxCollider>().enabled = true;
            child.gameObject.layer = LayerMask.NameToLayer("chest");
        }
    }

    private void InitNumberEnemy()
    {
        numberEnemyRemainingInRoom = GameObject.FindObjectsOfType<Enemy>().Length;
    }

    //Fonction appelée dès qu'un ennemi meurt
    public void EnemyDead()
    {
        numberEnemyRemainingInRoom--;
        CheckEnemyAlive();
    }

    private void CheckEnemyAlive()
    {
        if (numberEnemyRemainingInRoom <= 0)
        {
            if(currentRoom != null && hasChangedRoom)
            {
                hasChangedRoom = false;
                OpenRoom(currentRoom);
                audioSrcCombat.Stop();
                audioSrcNonCombat.Play();
            }

        }
    }

    public void BossDestroyed()
    {
        OpenRoom(currentRoom);
        int nbPlayer = GameObject.FindGameObjectsWithTag("player").Length;

        SpawnerObject spawner = GameObject.FindObjectOfType<SpawnerObject>();

        //Génération d'une récompense par joueur et de l'échelle si le boss meurt
        spawner.dropPowerUp(currentRoom.transform.Find("placeholderPowerUp").transform.position, null, false);
        spawner.dropPowerUp(currentRoom.transform.Find("placeholderPowerUp2").transform.position, null, false);
        GameObject ladder = Instantiate(prefabLadder, currentRoom.transform.Find("placeholderLadder").transform.position, Quaternion.identity);
        ladder.transform.parent = currentRoom.transform;
    }

    // changé dans l'autre fichier (script detect entrance) -------------------------------------------------------------------------------------------------------------------------
    public void ChangeRoom(GameObject room)
    {
        hasChangedRoom = true;
        //tant qu'il reste du brouillard
        if (listFogs.Count != 0)
        {
            for (int i = 0; i < listFogs.Count; i++)
            {
                GameObject fogi = listFogs[i];
                if (fogi != null)
                {
                    //suppression du brouillard dans la salle ou le joueur est rentré
                    if (fogi.transform.position.x == room.transform.position.x && fogi.transform.position.z == room.transform.position.z)
                    {
                        GameObject fog = fogi;
                        listFogs.RemoveAt(i);
                        Destroy(fog);
                    }
                }
            }
        }
        int minEnnemy = 4;
        int maxEnnemy = 6;
        CloseRoom(room);
        currentRoom = room;
        GenerateAssets(room, minEnnemy, maxEnnemy);

        audioSrcNonCombat.Stop();
        audioSrcCombat.Play();
    }

    public void EnterBossRoom(GameObject room)
    {
        if (listFogs.Count != 0)
        {
            for (int i = 0; i < listFogs.Count; i++)
            {
                GameObject fogi = listFogs[i];
                if (fogi != null)
                {
                    //suppression du brouillard dans la salle ou le joueur est rentré
                    if (fogi.transform.position.x == room.transform.position.x && fogi.transform.position.z == room.transform.position.z)
                    {
                        GameObject fog = fogi;
                        listFogs.RemoveAt(i);
                        Destroy(fog);
                    }
                }
            }
        }
        room.GetComponent<NavMeshSurface>().BuildNavMesh();

        if (Lobby.isMainPlayer)
        {
            GameObject boss = Instantiate(prefabBossGiant, room.transform.position, Quaternion.identity);
            boss.name = "enemy" + Lobby.roomCode + 22; // -----------------------------------------------------------------------------------------------------------------------------------------
        }

        CloseRoom(room);
        currentRoom = room;

        GameObject.FindObjectOfType<Minimap>().refreshMinimap();

        audioSrcNonCombat.Stop();
        audioSrcCombat.Play();
    }

    void InitFirstFloor()
    {
        GameObject startingRoom = StartGenerationDungeon(maxRoom);

        //récupère tous les brouillard et les met dans une liste de type List
        GameObject[] fogs = GameObject.FindGameObjectsWithTag("fog");
        listFogs.Clear();
        foreach (GameObject fog in fogs)
        {

            //suppression du brouillard dans la salle de spawn
            if (fog.transform.position.x == startingRoom.transform.position.x && fog.transform.position.z == startingRoom.transform.position.z)
            {
                Destroy(fog);
            }
            else
            {
                listFogs.Add(fog);
            }
        }

        PlayerController.isInLobby = false;
        float angle = Vector2.SignedAngle(new Vector2(startingRoom.transform.forward.x, startingRoom.transform.forward.z), Vector2.up);
        startingRoom.transform.Find("SpawnPointPlayer1").Rotate(Vector3.up, -angle);
        startingRoom.transform.Find("SpawnPointPlayer1").tag = "spawn";
        startingRoom.transform.Find("SpawnPointPlayer2").Rotate(Vector3.up, -angle);
        startingRoom.transform.Find("SpawnPointPlayer2").tag = "spawn";
        startingRoom.transform.Find("SpawnPointPlayer3").Rotate(Vector3.up, -angle);
        startingRoom.transform.Find("SpawnPointPlayer3").tag = "spawn";
        startingRoom.transform.Find("SpawnPointPlayer4").Rotate(Vector3.up, -angle);
        startingRoom.transform.Find("SpawnPointPlayer4").tag = "spawn";

        audioSrcCombat = this.GetComponents<AudioSource>()[0];
        audioSrcNonCombat = this.GetComponents<AudioSource>()[1];
        audioSrcNonCombat.Play();

        // on initie les joueurs après la génération mais avant l'affichage de l'ui ---------------------------------------------------------------------------------------------------
        GameObject.Find("ScriptGame").GetComponent<Game>().InitNetwork();
        DontDestroyOnLoad(GameObject.Find("ScriptGame"));

        DontDestroyOnLoad(GameObject.FindObjectOfType<Minimap>());
        StartCoroutine(CoroutineInitUI());
        // cameraManager.Follow = GameObject.FindObjectOfType<Warriors>().transform;
        // cameraManager.LookAt = GameObject.FindObjectOfType<Warriors>().transform; 
    }

    IEnumerator CoroutineInitUI()
    {
        yield return new WaitForSeconds(0.1f);
        GameObject.FindObjectOfType<UIHandler>().InitUI();
        foreach (Inventory inventory in GameObject.FindObjectsOfType<Inventory>())
            inventory.Init();
        DontDestroyOnLoad(GameObject.Find("player" + Lobby.login));
        DontDestroyOnLoad(GameObject.FindObjectOfType<Canvas>());
        DontDestroyOnLoad(GameObject.FindObjectOfType<CinemachineVirtualCamera>());
        DontDestroyOnLoad(Camera.main);
    }

    void InitNextFloor()
    {
        if (floor != endFloor) //si ce n'est pas la scène de fin
        {
            GameObject startingRoom = StartGenerationDungeon(maxRoom);

            //récupère tous les brouillard et les met dans une liste de type List
            GameObject[] fogs = GameObject.FindGameObjectsWithTag("fog");
            listFogs.Clear();
            foreach (GameObject fog in fogs)
            {
                //suppression du brouillard dans la salle de spawn
                if (fog.transform.position.x == startingRoom.transform.position.x && fog.transform.position.z == startingRoom.transform.position.z)
                {
                    Destroy(fog);
                }
                else
                {
                    listFogs.Add(fog);
                }
            }

            float angle = Vector2.SignedAngle(new Vector2(startingRoom.transform.forward.x, startingRoom.transform.forward.z), Vector2.up);
            startingRoom.transform.Find("SpawnPointPlayer1").Rotate(Vector3.up, -angle);
            startingRoom.transform.Find("SpawnPointPlayer1").tag = "spawn";
            startingRoom.transform.Find("SpawnPointPlayer2").Rotate(Vector3.up, -angle);
            startingRoom.transform.Find("SpawnPointPlayer2").tag = "spawn";
            startingRoom.transform.Find("SpawnPointPlayer3").Rotate(Vector3.up, -angle);
            startingRoom.transform.Find("SpawnPointPlayer3").tag = "spawn";
            startingRoom.transform.Find("SpawnPointPlayer4").Rotate(Vector3.up, -angle);
            startingRoom.transform.Find("SpawnPointPlayer4").tag = "spawn";

            //audioSrcCombat = this.GetComponents<AudioSource>()[0];
            //audioSrcNonCombat = this.GetComponents<AudioSource>()[1];
            //audioSrcNonCombat.Play();

            player = GameObject.Find("player" + Lobby.login).gameObject;
            CinemachineVirtualCamera cameraManager = (GameObject.Find("CameraManager")).GetComponent<CinemachineVirtualCamera>();
            cameraManager.Follow = player.GetComponent<Players>().transform;
            cameraManager.LookAt = player.GetComponent<Players>().transform;

            // on initie les joueurs après la génération mais avant l'affichage de l'ui ---------------------------------------------------------------------------------------------------
            GameObject.Find("ScriptGame").GetComponent<Game>().InitNetwork();
            //DontDestroyOnLoad(GameObject.Find("ScriptGame"));

            audioSrcCombat = this.GetComponents<AudioSource>()[0];
            audioSrcNonCombat = this.GetComponents<AudioSource>()[1];
            audioSrcNonCombat.Play();
            //player.transform.position = startingRoom.transform.Find("SpawnPointPlayer1").transform.position;
        }
    }

    private void Start()
    {
        string roomCode = Lobby.roomCode;
        string convertion = "";

        for (int i = 0; i < roomCode.Length; i++)
            convertion += System.Convert.ToInt32(roomCode[i]).ToString();

        convertion += floor.ToString();

        long seed = long.Parse(convertion);

        while (Mathf.Abs(seed) > int.MaxValue)
            seed %= int.MaxValue;

        UnityEngine.Random.InitState((int)seed);

        if (floor == 1)
            InitFirstFloor();
        else
            InitNextFloor();

        //ignore les collisions entre le brouillard (10) et les joueurs (7)
        Physics.IgnoreLayerCollision(0, 10);
        Physics.IgnoreLayerCollision(7, 10);

        CinemachineVirtualCamera cameraManager = (GameObject.Find("CameraManager")).GetComponent<CinemachineVirtualCamera>();
        var rotation = Camera.main.transform.localRotation.eulerAngles;
        rotation.Set(rotation.x, 0, rotation.z);
        Camera.main.transform.localRotation = Quaternion.Euler(rotation);
        StartCoroutine(DoCheck());
    }

    IEnumerator DoCheck() {
     while(true) {
        InitNumberEnemy();
        CheckEnemyAlive();
         yield return new WaitForSeconds(1f);
     }
    }

    void Update()
    {
        if(Input.GetKeyDown(KeyCode.K))
        {
            Enemy[] allEnemy = GameObject.FindObjectsOfType<Enemy>();
            if(allEnemy != null)
                for(int i = 0; i < allEnemy.Length; i++)
                    Destroy(allEnemy[i].gameObject);
            
            if(currentRoom != null)
                OpenRoom(currentRoom);
        }
    }

}
