using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;

public class ScriptMerchant : MonoBehaviour
{

    public int priceKey;
    public int priceHealthPotion;
    public int pricePowerUp;
    // Start is called before the first frame update
    void Start()
    {

        //Génération aléatoire des prix
        priceKey = Random.Range(5,10);
        priceHealthPotion = Random.Range(8,13);
        pricePowerUp = Random.Range(10,15);

        //Mise à jour des prix affichés
        updatePrice();

        gameObject.transform.Find("Key").GetComponent<MerchantKey>().price = priceKey;
        gameObject.transform.Find("HealthPotion").GetComponent<MerchantHealthPotion>().price = priceHealthPotion;
        
        //Récupération d'un powerUP aléatoire
        GameObject[] assetPowerUp = Resources.LoadAll<GameObject>("PowerUpMerchant");
        GameObject powerUp = assetPowerUp[ScriptGenerationDonjon.randomPersonal.Next(0, assetPowerUp.Length)];

        //Instantiation du powerup d'exposition
        GameObject newObject = Instantiate(powerUp, gameObject.transform.Find("PowerUp").position, Quaternion.identity);

        newObject.transform.LookAt(Camera.main.transform);

        newObject.transform.parent = gameObject.transform;

        //Attribution du powerup à l'étal du powerup pour que ce soit le bon powerup que le joueur achète
        newObject.GetComponent<MerchantPowerUp>().powerUp = newObject;

        newObject.GetComponent<MerchantPowerUp>().price = pricePowerUp;

    }

    public void updatePrice()
    {
        gameObject.transform.Find("KeyText").GetComponent<TextMeshPro>().text = priceKey + " PO";
        gameObject.transform.Find("HealthPotionText").GetComponent<TextMeshPro>().text = priceHealthPotion + " PO";
        gameObject.transform.Find("PowerUpText").GetComponent<TextMeshPro>().text = pricePowerUp + " PO";
    }

    void Update()
    {
        //Rotation des prix
        gameObject.transform.Find("KeyText").rotation = Quaternion.LookRotation( gameObject.transform.Find("KeyText").position - Camera.main.transform.position );
        gameObject.transform.Find("HealthPotionText").rotation = Quaternion.LookRotation( gameObject.transform.Find("HealthPotionText").position - Camera.main.transform.position );
        gameObject.transform.Find("PowerUpText").rotation = Quaternion.LookRotation( gameObject.transform.Find("PowerUpText").position - Camera.main.transform.position );

    }
}
