using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AI;

public class ScriptPathfindingEnnemy : MonoBehaviour
{
    private NavMeshAgent nav;
    public bool playerDetected = false;

    public List<GameObject> target;

    private GameObject mainTarget;

    private float speed;

    public bool isDistance;

    private Animator anim;

    private Rigidbody rb;
    // Start is called before the first frame update
    void Start()
    {
        // Au départ les ennemis partent tout droit dans une direction aléatoire
        nav = GetComponent<NavMeshAgent>();
        rb = GetComponent<Rigidbody>();
        var rot = gameObject.transform.localRotation.eulerAngles;
        float randomAngle = ScriptGenerationDonjon.randomPersonal.Next(0, 360);
        speed = gameObject.GetComponent<Enemy>().stats.speed;
        anim = gameObject.GetComponent<Animator>();
        

        anim.SetBool("MovingForward", true);
        anim.SetFloat("SpeedMultiplier", speed/5);
        rot.Set(0, randomAngle, 0);
        
        gameObject.transform.localRotation = Quaternion.Euler(rot);
    }

    public void NewTarget()
    {
        if(playerDetected)
        {

            // Méthode à implémenter pour connaitre la priorité de la cible à attaquer
            if(mainTarget == null || mainTarget.GetComponent<Players>().stats.currentHp <= 0)
                target.Remove(mainTarget);
            if(target.Count != 0)
                mainTarget = target[0];
            else
                playerDetected = false;
        }
    }

    //Si un ennemi rencontre un obstacle il va juste faire demi-tour
    public void DetectObstacle()
    {
        if (!playerDetected)
        {
            var rot = gameObject.transform.localRotation.eulerAngles;
            rot.Set(0, rot.y + 180f, 0);
            gameObject.transform.localRotation = Quaternion.Euler(rot);
        }
    }

    bool checkAlive()
    {
        if (gameObject.GetComponent<Enemy>().stats.currentHp <= 0)
        {
            nav.speed = 0;
            return false;
        }
        return true;
    }


    //Si l'ennemi a trouvé un joueur, c'est navmesh qui va faire le taf, sinon on le fait bouger nous-même avec transform.Translate
    void Update()
    {
        NewTarget();
        if(!checkAlive())
            return;

        if (!playerDetected)
        {
            if (!anim.GetBool("IsTriggered") && !anim.GetBool("IsDead") && checkAlive())
            {
                transform.Translate(Vector3.forward * speed * Time.deltaTime);
            }
            else if(checkAlive())
            {
                nav.speed = 0;
            }
        }
        else
        {
            if(!checkAlive())
                return;
            nav.destination = mainTarget.transform.position;
            if(!isDistance)
                nav.stoppingDistance = 3;
            else
                nav.stoppingDistance = 15;
            if (!anim.GetBool("IsTriggered") && !anim.GetBool("IsDead") && checkAlive())
            {
                nav.speed = speed;
            }
            else if(checkAlive())
            {
                nav.speed = 0;
            }
        }

        if(!isDistance)
        {

            //Condition pour que l'ennemi s'arrête un peu avant le joueur
            if(nav.remainingDistance < 3 && playerDetected && checkAlive())
            {
                anim.SetBool("MovingForward", false);
                //gameObject.GetComponent<Enemy>().Attack();
            }
            else if(checkAlive())
                anim.SetBool("MovingForward", true);
        }
        else
        {
             //Condition pour que l'ennemi s'arrête un peu avant le joueur
            if(nav.remainingDistance < 15 && playerDetected && checkAlive())
            {
                anim.SetBool("MovingForward", false);
                //gameObject.GetComponent<Enemy>().Attack();
            }
            else if(checkAlive())
                anim.SetBool("MovingForward", true);
        }
    }

}
