using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class Inventory : MonoBehaviour
{

    public int coins = 0;
    public int healthPotions = 1;
    public int key = 0;

    UsableCounter UI;

    public void Init()
    {
        UI = GameObject.FindObjectOfType<UsableCounter>();
        UI.DisplayCoins(coins);
        UI.DisplayKey(key);
        UI.DisplayHealthPotion(healthPotions);
    }


    public void addCoins()
    {
        coins++;
        if (UI != null)
            UI.DisplayCoins(coins);
    }
    public void addKey()
    {
        key++;
        if (UI != null)
            UI.DisplayKey(key);
    }
    public void addHealthPotion()
    {
        healthPotions++;
        if (UI != null)
            UI.DisplayHealthPotion(healthPotions);
    }
    public bool removeCoins(int nbCoins)
    {
        if (coins >= nbCoins)
        {
            coins -= nbCoins;
            if (UI != null)
                UI.DisplayCoins(coins);

            return true;
        }
        return false;
    }

    public bool RemoveKey()
    {
        if (key > 0)
        {
            key--;
            if (UI != null)
                UI.DisplayKey(key);
            return true;
        }
        return false;
    }

    public bool usePotion()
    {
        if (healthPotions > 0)
        {
            healthPotions--;
            if (UI != null)
                UI.DisplayHealthPotion(healthPotions);
            return true;
        }
        return false;
    }

    public int GetCoins() { return coins; }
    public int GetHealthPotions() { return healthPotions; }
    public int GetKey() { return key; }
}
