using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public abstract class PowerUp : MonoBehaviour
{
    // Start is called before the first frame update
    private string textPowerUp;
    private bool powerUpTaken = false;


    //Active le pouvoir pour un certain joueur, désactive certain composants du gameobject
    public void Activate(Players player)
    {
            if(!powerUpTaken)
            {
                powerUpTaken = true;
                activatePowerUp(player);
                gameObject.transform.Find("Quad").GetComponent<MeshRenderer>().enabled = false;
                gameObject.transform.Find("Fire").GetComponent<ParticleSystem>().Stop();
                gameObject.transform.Find("Light").GetComponent<Light>().enabled = false;
            }
    }

    void Update()
    {
        gameObject.transform.LookAt(Camera.main.transform);
    }

    protected void SetUpPowerUp()
    {
        //Débute la destruction de l'objet (affichage du texte et programmation de la destruction)
        gameObject.transform.Find("Text").GetComponent<MeshRenderer>().enabled = true;
        gameObject.transform.Find("Text").GetComponent<Animator>().SetTrigger("TextFadeIn");
        Destroy(gameObject, 2.0f);
    }

    public abstract void  activatePowerUp(Players player);

}
