using System.Collections;
using System.Collections.Generic;
using UnityEngine;



//Classe qui gère l'intégralité du spawn d'objets
public class SpawnerObject : MonoBehaviour
{

    public GameObject coinsPrefab;

    public GameObject keyPrefab;

    public GameObject healthPotionPrefab;

    public GameObject[] arrayPrefabPowerUp;

    // Start is called before the first frame update
    void Start()
    {
        
    }


    public void lootOpenChest(Vector3 position, GameObject chest)
    {
        dropCoins(300, ScriptGenerationDonjon.randomPersonal.Next(15,25), position, chest);

        dropHealthPotion(300, position, chest);

        if(ScriptGenerationDonjon.randomPersonal.NextDouble() > 0.3f)
            dropKey(300,position, chest);
        
        if(ScriptGenerationDonjon.randomPersonal.NextDouble() > 0.5f)
            dropPowerUp(position, chest, false);
        
    }

    public void lootClosedChest(Vector3 position, GameObject chest)
    {
        dropCoins(300, ScriptGenerationDonjon.randomPersonal.Next(25,30), position, chest);

        int numberHealthPotion = ScriptGenerationDonjon.randomPersonal.Next(1,4);
        for(int i = 0; i < numberHealthPotion; i++)
            dropHealthPotion(300, position, chest);
        
        dropPowerUp(position, chest, false);
        
        
    }

    //Instancie une clé qui part dans une direction aléatoire et ignore la collision avec le coffre pour éviter des bugs de collision
    public void dropKey(int force, Vector3 position, GameObject source)
    {
        float randomNumberDirection = (float) ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);

        Vector3 forceVector; 
        forceVector = new Vector3(Mathf.Cos(randomNumberDirection) * force, 200, Mathf.Sin(randomNumberDirection) * force);
        GameObject newKey = Instantiate(keyPrefab, position, Quaternion.identity);

        Physics.IgnoreCollision(newKey.GetComponent<Collider>(), source.GetComponent<Collider>());

        newKey.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);

        //Oblige la clé à s'arrêter de tourner
        newKey.GetComponent<Rigidbody>().drag = 0.5f;
    }

    //Instancie une clé qui part vers le joueur et ignore la collision avec le coffre pour éviter des bugs de collision
    public void dropKey(int force, Vector3 position, GameObject source, GameObject ignoreGameObject)
    {
        float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);

        Vector3 forceVector; 
        forceVector = (source.transform.position - position).normalized * force*2;
        GameObject newKey = Instantiate(keyPrefab, position, Quaternion.identity);

        Physics.IgnoreCollision(newKey.GetComponent<Collider>(), ignoreGameObject.GetComponent<Collider>());

        newKey.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);
        //Oblige la clé à s'arrêter de tourner
        newKey.GetComponent<Rigidbody>().drag = 0.5f;
    }

    //Instancie une potion de soin qui part dans une direction aléatoire et ignore la collision avec le coffre pour éviter des bugs de collision
    public void dropHealthPotion(int force, Vector3 position, GameObject source)
    {
        float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);
        Vector3 forceVector;
        forceVector = new Vector3(Mathf.Cos(randomNumberDirection) * force, 200, Mathf.Sin(randomNumberDirection) * force);
        GameObject newPotion = Instantiate(healthPotionPrefab, position, Quaternion.identity);

        Physics.IgnoreCollision(newPotion.GetComponent<Collider>(), source.GetComponent<Collider>());

        newPotion.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);
        //Oblige la potion à s'arrêter de tourner
        newPotion.GetComponent<Rigidbody>().drag = 0.5f;
    }

    //Instancie une potion de soin qui part vers le joueur et ignore la collision avec le coffre pour éviter des bugs de collision
    public void dropHealthPotion(int force, Vector3 position, GameObject source, GameObject ignoreGameObject)
    {
        float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);
        Vector3 forceVector;
        forceVector = (source.transform.position - position).normalized * force;
        GameObject newPotion = Instantiate(healthPotionPrefab, position, Quaternion.identity);

        Physics.IgnoreCollision(newPotion.GetComponent<Collider>(), ignoreGameObject.GetComponent<Collider>());

        newPotion.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);
        //Oblige la potion à s'arrêter de tourner
        newPotion.GetComponent<Rigidbody>().drag = 0.5f;
    }


    //Instancie nbCoins pièces qui part dans une direction aléatoire et ignore la collision avec le coffre et les autres pièces pour éviter des bugs de collision
    public void dropCoins(int force, int nbCoins, Vector3 position, GameObject source)
    {
        GameObject[] listCoins = new GameObject[nbCoins];
        for (int i = 0; i < nbCoins; i++)
        {
            float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);

            Vector3 forceVector = new Vector3(Mathf.Cos(randomNumberDirection) * force, 200, Mathf.Sin(randomNumberDirection) * force);
            GameObject newCoin = Instantiate(coinsPrefab, position, Quaternion.identity);

            for (int j = 0; j < i; j++)
                Physics.IgnoreCollision(newCoin.GetComponent<Collider>(), listCoins[j].GetComponent<Collider>());

            Physics.IgnoreCollision(newCoin.GetComponent<Collider>(), source.GetComponent<Collider>());
            listCoins[i] = newCoin;

            newCoin.GetComponent<Rigidbody>().AddForce(forceVector, ForceMode.Force);
            newCoin.GetComponent<Rigidbody>().drag = 0.5f;
        }
    }

    //Instancie un powerup aléatoire qui part dans une direction aléatoire
    public void dropPowerUp(Vector3 position, GameObject source, bool merchant)
    {
        float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);
        GameObject powerUp = Instantiate(arrayPrefabPowerUp[ScriptGenerationDonjon.randomPersonal.Next(0,arrayPrefabPowerUp.Length)], position + (new Vector3(Mathf.Cos(randomNumberDirection)*5, 1, Mathf.Sin(randomNumberDirection)* 5)),Quaternion.identity);
        if (!merchant)
            powerUp.layer = LayerMask.NameToLayer("chest");

    }

    //Instancie un powerup spécifique qui part vers le joueur (marchand)
    public void dropPowerUp(Vector3 position, GameObject source, GameObject newPower)
    {
        float randomNumberDirection = (float)ScriptGenerationDonjon.randomPersonal.NextDouble() * (2 * Mathf.PI);
        Vector3 vectorPositionPowerUp = position + (source.transform.position - position).normalized * 3;
        GameObject powerUp = Instantiate(newPower, new Vector3(vectorPositionPowerUp.x, 1, vectorPositionPowerUp.z),Quaternion.identity);
        powerUp.layer = LayerMask.NameToLayer("chest");
    }
}
