using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Networking;
using Newtonsoft.Json;
using UnityEngine.UI;

public class GetInput : MonoBehaviour
{
    public GameObject LoginMenu;
    public GameObject LobbyMenu;
    public GameObject ConnectionPlayerFailure;

    public InputField InputFieldLogin;
    public InputField InputFieldPassword;

    private string Login = "";
    private string Password = "";


    void OnEnable()
    {
        ConnectionPlayerFailure.SetActive(false);
        InputFieldLogin.text = "";
        InputFieldPassword.text = "";
    }

    public void GetId(string s)
    {
        Login = s;
    }

    public void GetPassword(string s)
    {
        Password = s;
    }

    public void Click()
    {
        if (Login != "" && Password != "")
            StartCoroutine(GetText());
        else
            ConnectionPlayerFailure.SetActive(true);
    }

    IEnumerator GetText()
    {
        WWWForm Form = new WWWForm();
        Form.AddField("Login", Login);
        Form.AddField("Password", Password);

        using (UnityWebRequest WebRequest = UnityWebRequest.Post("https://mai-projet-integrateur.u-strasbg.fr/vmProjetIntegrateurgrp6-0/login.php", Form))
        {
            yield return WebRequest.SendWebRequest();

            // La connexion au serveur a echoue
            if (WebRequest.result == UnityWebRequest.Result.ConnectionError || WebRequest.result == UnityWebRequest.Result.ProtocolError)
            {
                Debug.Log(WebRequest.error);
            }
            // La connexion au serveur a reussi
            else
            {
                if (WebRequest.isDone)
                {
                    var RequestRes = JsonConvert.DeserializeObject<Dictionary<string, string>>(WebRequest.downloadHandler.text);


                    // Les identifiants renseignes par l'utilisateur sont corrects
                    if (RequestRes["IsSuccessful"] == "1")
                    {
                        LoginMenu.SetActive(false);
                        LobbyMenu.SetActive(true);
                    }


                    // Les identifiants renseignes par l'utilisateur sont erronnes
                    else if (RequestRes["IsSuccessful"] == "0")
                    {
                        ConnectionPlayerFailure.SetActive(true);
                    }
                }

            }
        }
    }
}