using Newtonsoft.Json;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemySend : MonoBehaviour
{
    private PlayerDataSimple infoSendSimple = new PlayerDataSimple();
    private Statistics stats;

    public static bool shouldJoinLobby = true;

    public string enemyName;


    private void Start()
    {
        if (enemyName == "Range Minion")
            stats = gameObject.GetComponent<RangeMinion>().stats;
        else if (enemyName == "Melee Minion")
            stats = gameObject.GetComponent<MeleeMinion>().stats;
        else if (enemyName == "Boss Giant")
            stats = gameObject.GetComponent<BossGiant>().stats;
        
        // initialisation des paquets 
        infoSendSimple.roomCode = Lobby.roomCode;
        infoSendSimple.createLobby = "false";
        infoSendSimple.isReady = "true";
        infoSendSimple.login = gameObject.name;
        infoSendSimple.type = enemyName;

        // on enregistre l'ennemi sur le serveur (si c'est pas encore fait seulement)
        if (shouldJoinLobby)
        {
            infoSendSimple.inLobby = "false";
            SendDataToServer();

            // on n'attend pas la rponse car elle arriverait sur celui qui host les ennemis (le maitre du jeu)
            infoSendSimple.inLobby = "true";
        }

        // frequence des envois rseau (30x par seconde: 0.033f) ------------------------------------------------------------------------------------------------------
        InvokeRepeating("SendDataToServer", 0, 0.033f);
    }

    // l'envoi des donnes du joueur local au serveur (selon la frquence dfinit plus haut) --------------------------------------------------------------------------
    public void SendDataToServer()
    {
        // on se prpare  envoier ses points de vie ( modifier par une personne comptente)
        infoSendSimple.hitPoint = stats.currentHp.ToString();

        // on se prpare  envoier sa position et rotation
        infoSendSimple.posX = gameObject.transform.position.x.ToString().Replace(".", ",");
        infoSendSimple.posY = gameObject.transform.position.y.ToString().Replace(".", ",");
        infoSendSimple.posZ = gameObject.transform.position.z.ToString().Replace(".", ",");
        infoSendSimple.rotY = gameObject.transform.localEulerAngles.y.ToString().Replace(".", ",");

        // envoie des donnes au serveur qui les redonnera aux autres joueurs
        Lobby.socket.SendAsync(JsonConvert.SerializeObject(infoSendSimple));
    }

    // une mthode qui s'excute  la mort pour que les ennemis partent du lobby
    public void RemoveFromLobby()
    {
        // on arrte de lui envoyer les donnes de l'ennemi
        CancelInvoke("SendDataToServer");

        // on se prpare  dire au serveur qu'un ennemi est mort
        infoSendSimple.hitPoint = (0).ToString();
        infoSendSimple.roomCode = "";
        infoSendSimple.inLobby = "false";

        // puis on lui dit
        Lobby.socket.SendAsync(JsonConvert.SerializeObject(infoSendSimple));
    }
}
