using Newtonsoft.Json;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using UnityWebSocket;

public class Game : MonoBehaviour
{
    // les diffrentes prfab des joueurs et ennemis ( complter en temps voulu)
    [SerializeField] private GameObject prefabWarrior;
    [SerializeField] private GameObject prefabArcher;
    [SerializeField] private GameObject prefabMeleeMinion;
    [SerializeField] private GameObject prefabRangeMinion;
    [SerializeField] private GameObject prefabBossGiant;


    public void InitNetwork()
    {
        // on cherche le point de spawn en fonction de notre numro de joueur
        GameObject startPosition = GameObject.Find("SpawnPointPlayer" + Lobby.playerNumber);

        // on charge le joueur local au point de spawn au chargement de la scne
        if (Lobby.player == null)
        {
            Lobby.player = Instantiate(PlayerSelection.currentPrefab, startPosition.transform.position, Quaternion.Euler(0, 0, 0));
            Lobby.player.name = "player" + Lobby.login;
        }
        else
        {
            Lobby.player.transform.position = startPosition.transform.position;
        }

        // la fonction qui sera appele  chaque paquet reu du serveur
        Lobby.socket.OnMessage += FunctionOnMessage3;

        // frquence des envois rseau : 30x par seconde l (0.033f)
        InvokeRepeating("SendDataToServer", 0, 0.033f);
    }

    // quand on appuie sur le bouton quitter
    public static void LeaveGame()
    {
        // on se prpare  dire au serveur qu'on se casse
        Lobby.infoSendSimple.roomCode = "";
        Lobby.infoSendSimple.inLobby = "false";

        // puis on lui dit
        Lobby.socket.SendAsync(JsonConvert.SerializeObject(Lobby.infoSendSimple));
    }

    // la fonction appele  chaque paquet reu du serveur
    public void FunctionOnMessage3(object sender, MessageEventArgs message)
    {
        if (message.IsText)
        {
            // on parse le JSON reu par le serveur
            Lobby.infoRecvOnline = JsonConvert.DeserializeObject<PlayerDataOnline>(message.Data);

            // on traite le paquet reu selon le code erreur
            switch (int.Parse(Lobby.infoRecvOnline.errorCode))
            {
                // le cas o tout va bien (quasiment toujours ce cas)
                case 0:
                    {
                        // si le maitre de jeu a chang de scne, on fait pareil
                        if (!Lobby.isMainPlayer && SceneManager.GetActiveScene().name != Lobby.infoRecvOnline.currentScene)
                        {
                            if (ScriptGenerationDonjon.floor < 3)
                                FindObjectOfType<ScriptGenerationDonjon>().EventChangeFloor();
                        }

                        // mise  jour des barres de vie des joueurs ( faire par quelqu'un svp)

                        // on vrifie si on a rcupr le role du maitre de jeu
                        if (Lobby.infoRecvOnline.mainPlayer == Lobby.login)
                            Lobby.isMainPlayer = true;

                        // pour chacun des joueurs et ennemis dans le lobby...
                        for (int i = 0; i < Lobby.infoRecvOnline.login.Length; i++)
                        {
                            // on obtient les nouvelles postion et rotation
                            Vector3 newPosition = new Vector3(float.Parse(Lobby.infoRecvOnline.posX[i], System.Globalization.CultureInfo.GetCultureInfo("fr-FR")), float.Parse(Lobby.infoRecvOnline.posY[i], System.Globalization.CultureInfo.GetCultureInfo("fr-FR")), float.Parse(Lobby.infoRecvOnline.posZ[i], System.Globalization.CultureInfo.GetCultureInfo("fr-FR")));
                            Quaternion newRotation = Quaternion.Euler(0, float.Parse(Lobby.infoRecvOnline.rotY[i], System.Globalization.CultureInfo.GetCultureInfo("fr-FR")), 0);

                            // on passe au suivant si on traite notre propre joueur
                            if (Lobby.infoRecvOnline.login[i] == Lobby.login) continue;

                            // si on est en train de traiter un joueur
                            if (Lobby.playersType.IndexOf(Lobby.infoRecvOnline.type[i]) != -1)
                            {
                                // on chope le joueur concern
                                GameObject allie = GameObject.Find("player" + Lobby.infoRecvOnline.login[i]);

                                // si on le trouve pas, c'est qu'il vient d'arriver
                                if (allie == null)
                                {
                                    // alors on le cre 
                                    allie = Instantiate((Lobby.infoRecvOnline.type[i] == "Warrior" ? prefabWarrior : prefabArcher), newPosition, newRotation);
                                    allie.name = "player" + Lobby.infoRecvOnline.login[i];
                                    DontDestroyOnLoad(allie);

                                    // on met la vitesse de l'animation de marche  1
                                    allie.GetComponent<Animator>().SetFloat("SpeedMultiplier", 1);

                                    // et on dsactive les objets qui ne doivent pas interfrer (important !)
                                    allie.GetComponent<PlayerController>().enabled = false;
                                    allie.GetComponent<PlayerCameraFocus>().enabled = false;
                                    allie.GetComponent<PlayerInput>().enabled = false;

                                    // on mets  jour le nombre de joueurs
                                    Lobby.nbPlayers = 0;
                                    for (int k = 0; k < Lobby.infoRecvOnline.login.Length; k++)
                                    {
                                        if (Lobby.playersType.IndexOf(Lobby.infoRecvOnline.type[k]) != -1)
                                            Lobby.nbPlayers++;
                                    }
                                }

                                // enfin on applique les nouvelles position et rotation
                                allie.transform.position = newPosition;
                                allie.transform.rotation = newRotation;

                                if (SceneManager.GetActiveScene().name == "EndScene")
                                {
                                    //active l'animation de danse 
                                    allie.GetComponent<Animator>().SetBool("isDancing", true);

                                    //enlve l'arme (en dterminant si c'est l'archer ou le warrior par leurs chapeaux Hat/helmet)
                                    if (allie.transform.Find("Hat") != null)
                                    {
                                        if (allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:LeftShoulder/mixamorig:LeftArm/mixamorig:LeftForeArm/mixamorig:LeftHand/arc2") != null)
                                            Destroy(allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:LeftShoulder/mixamorig:LeftArm/mixamorig:LeftForeArm/mixamorig:LeftHand/arc2").gameObject);
                                    }
                                    else
                                    {
                                        if (allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:RightShoulder/mixamorig:RightArm/mixamorig:RightForeArm/mixamorig:RightHand/epeeLongue") != null)
                                            Destroy(allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:RightShoulder/mixamorig:RightArm/mixamorig:RightForeArm/mixamorig:RightHand/epeeLongue").gameObject);

                                        if (allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:LeftShoulder/mixamorig:LeftArm/mixamorig:LeftForeArm/mixamorig:LeftHand/shield") != null)
                                            Destroy(allie.transform.Find("mixamorig:Hips/mixamorig:Spine/mixamorig:Spine1/mixamorig:Spine2/mixamorig:LeftShoulder/mixamorig:LeftArm/mixamorig:LeftForeArm/mixamorig:LeftHand/shield").gameObject);
                                    }

                                    allie.transform.localScale = new Vector3(0.15f, 0.15f, 0.15f);
                                    allie.transform.eulerAngles = new Vector3(0f, 0f, 0f);
                                }

                                // gestion des PV
                                allie.GetComponent<Players>().stats.currentHp = int.Parse(Lobby.infoRecvOnline.hitPoint[i]);

                                if (Lobby.infoRecvOnline.animMoveForward[i] == "true")
                                    allie.GetComponent<Animator>().SetBool("MovingForward", true);
                                else
                                    allie.GetComponent<Animator>().SetBool("MovingForward", false);

                                if (Lobby.infoRecvOnline.animMoveBackward[i] == "true")
                                    allie.GetComponent<Animator>().SetBool("MovingBackward", true);
                                else
                                    allie.GetComponent<Animator>().SetBool("MovingBackward", false);

                                if (Lobby.infoRecvOnline.animMoveRight[i] == "true")
                                    allie.GetComponent<Animator>().SetBool("MovingRight", true);
                                else
                                    allie.GetComponent<Animator>().SetBool("MovingRight", false);

                                if (Lobby.infoRecvOnline.animMoveLeft[i] == "true")
                                    allie.GetComponent<Animator>().SetBool("MovingLeft", true);
                                else
                                    allie.GetComponent<Animator>().SetBool("MovingLeft", false);

                                if (Lobby.infoRecvOnline.animAttack[i] == "true")
                                {
                                    if (Lobby.infoRecvOnline.type[i] == "Warrior")
                                        StartCoroutine(allie.GetComponent<Warriors>().Attack(Lobby.infoRecvOnline.login[i]));
                                    else if (Lobby.infoRecvOnline.type[i] == "Archer")
                                        StartCoroutine(allie.GetComponent<Archers>().Attack(Lobby.infoRecvOnline.login[i]));
                                }

                                if (Lobby.infoRecvOnline.animSpeAtt[i] == "true")
                                {
                                    if (Lobby.infoRecvOnline.type[i] == "Warrior")
                                        StartCoroutine(allie.GetComponent<Warriors>().SecondAttack(Lobby.infoRecvOnline.login[i]));
                                    else if (Lobby.infoRecvOnline.type[i] == "Archer")
                                        StartCoroutine(allie.GetComponent<Archers>().SecondAttack(Lobby.infoRecvOnline.login[i]));
                                }

                                if (Lobby.infoRecvOnline.type[i] == "Archer" && Lobby.infoRecvOnline.animRoll[i] == "true")
                                {
                                    Debug.Log("un archer alli veut rouler !");
                                    StartCoroutine(allie.GetComponent<Archers>().SpecialMovement(Lobby.infoRecvOnline.login[i], gameObject.GetComponent<PlayerController>().direction));
                                }

                                if (Lobby.infoRecvOnline.type[i] == "Warrior" && Lobby.infoRecvOnline.animShield[i] == "true")
                                {
                                    allie.GetComponent<Warriors>().StartBlock();
                                }
                                if (Lobby.infoRecvOnline.type[i] == "Warrior" && Lobby.infoRecvOnline.animShield[i] == "false")
                                {
                                    allie.GetComponent<Warriors>().EndBlock();
                                }

                                if (allie.GetComponent<Players>().stats.currentHp <= 0)
                                {
                                    allie.GetComponent<Players>().Die();
                                }
                            }
                            // sinon c'est un ennemi (mais le maitre de jeu s'en fiche, il a les vrais !)
                            else if (!Lobby.isMainPlayer && (Lobby.infoRecvOnline.type[i] == "Melee Minion" || Lobby.infoRecvOnline.type[i] == "Range Minion"))
                            {
                                // on chope l'ennemi concern
                                GameObject enemy = GameObject.Find(Lobby.infoRecvOnline.login[i]);

                                // si on le trouve pas, c'est qu'il vient d'arriver
                                if (enemy == null)
                                {
                                    // alors on le cre 
                                    enemy = Instantiate((Lobby.infoRecvOnline.type[i] == "Melee Minion" ? prefabMeleeMinion : prefabRangeMinion), newPosition, newRotation);
                                    enemy.name = Lobby.infoRecvOnline.login[i];
                                    ScriptGenerationDonjon.numberEnemyRemainingInRoom++;

                                    // on update la minimap pour inclure le nouvel ennemi
                                    FindObjectOfType<Minimap>().refreshMinimap();

                                    // et on dsactive les objets qui ne doivent pas interfrer (important !)
                                    enemy.GetComponent<EnemySend>().enabled = false;
                                    EnemySend.shouldJoinLobby = false;
                                }

                                // enfin on applique les nouvelles position et rotation
                                enemy.transform.position = newPosition;
                                enemy.transform.rotation = newRotation;

                                // gestion des PV
                                if (Lobby.infoRecvOnline.type[i] == "Melee Minion")
                                {
                                    if (enemy.GetComponent<MeleeMinion>().stats != null)
                                        enemy.GetComponent<MeleeMinion>().stats.currentHp = int.Parse(Lobby.infoRecvOnline.hitPoint[i]);

                                    if (enemy.GetComponent<MeleeMinion>().stats != null && enemy.GetComponent<MeleeMinion>().stats.currentHp <= 0)
                                    {
                                        enemy.GetComponent<MeleeMinion>().Die();
                                    }
                                }
                                else
                                {
                                    if (enemy.GetComponent<RangeMinion>().stats != null)
                                        enemy.GetComponent<RangeMinion>().stats.currentHp = int.Parse(Lobby.infoRecvOnline.hitPoint[i]);

                                    if (enemy.GetComponent<RangeMinion>().stats != null && enemy.GetComponent<RangeMinion>().stats.currentHp <= 0)
                                    {
                                        enemy.GetComponent<RangeMinion>().Die();
                                    }
                                }
                            }
                            // sinon c'est un boss (mais le maitre de jeu s'en fiche, il a le vrai !)
                            else if (!Lobby.isMainPlayer && Lobby.infoRecvOnline.type[i] == "Boss Giant")
                            {
                                // on chope l'ennemi concern
                                GameObject boss = GameObject.Find(Lobby.infoRecvOnline.login[i]);

                                // si on le trouve pas, c'est qu'il vient d'arriver
                                if (boss == null)
                                {
                                    // alors on le cre 
                                    boss = Instantiate(prefabBossGiant, newPosition, newRotation);
                                    boss.name = Lobby.infoRecvOnline.login[i];

                                    // on update la minimap pour inclure le nouvel ennemi
                                    FindObjectOfType<Minimap>().refreshMinimap();

                                    // et on dsactive les objets qui ne doivent pas interfrer (important !)
                                    boss.GetComponent<EnemySend>().enabled = false;
                                }

                                // enfin on applique les nouvelles position et rotation
                                boss.transform.position = newPosition;
                                boss.transform.rotation = newRotation;

                                // gestion des PV
                                if (boss.GetComponent<BossGiant>().stats != null)
                                    boss.GetComponent<BossGiant>().stats.currentHp = int.Parse(Lobby.infoRecvOnline.hitPoint[i]);

                                if (boss.GetComponent<BossGiant>().stats != null && boss.GetComponent<BossGiant>().stats.currentHp <= 0)
                                {
                                    boss.GetComponent<BossGiant>().Die();
                                }
                            }
                        }

                        break;
                    }

                // on reoit la confirmation qu'on a bien quitt le lobby
                case 24:
                    {
                        // on reset le numro de joueur et le code de room
                        Lobby.playerNumber = -1;
                        Lobby.roomCode = "";

                        Lobby.socket.OnMessage -= FunctionOnMessage3;

                        CancelInvoke("SendDataToServer");

                        // si jamais on tait chef de partie, bah on l'est plus
                        Lobby.isMainPlayer = false;

                        // et on retourne au menu principal
                        SceneManager.LoadScene("Main Menu");

                        break;
                    }

                // l'un des joueurs du lobby s'est casse (volontairement ou non)
                case 40:
                    {
                        // mise  jour des barres de vie des joueurs ( faire par quelqu'un svp)

                        // on vrifie si on a rcupr le role du maitre de partie
                        if (Lobby.infoRecvOnline.mainPlayer == Lobby.login)
                        {
                            Lobby.isMainPlayer = true;

                            GameObject[] currentEnemies = GameObject.FindGameObjectsWithTag("enemy");
                            foreach (GameObject enemy in currentEnemies)
                            {
                                enemy.GetComponent<EnemySend>().enabled = true;
                            }
                        }

                        // on mets  jour le nombre de joueurs et rcupre son potentiel nouveau numro de joueur
                        Lobby.nbPlayers = 0;
                        for (int k = 0; k < Lobby.infoRecvOnline.login.Length; k++)
                        {
                            if (Lobby.playersType.IndexOf(Lobby.infoRecvOnline.type[k]) != -1)
                                Lobby.nbPlayers++;

                            if (Lobby.infoRecvOnline.login[k] == Lobby.login)
                                Lobby.playerNumber = Lobby.nbPlayers;
                        }

                        // on chope tous les joueurs allis sur la scne
                        List<GameObject> allies = new List<GameObject>(GameObject.FindGameObjectsWithTag("player"));

                        // on enlve de la liste ceux dont on a encore reu des infos du serveur
                        for (int i = 0; i < Lobby.infoRecvOnline.login.Length; i++)
                        {
                            if (GameObject.Find("player" + Lobby.infoRecvOnline.login[i]) != null)
                                allies.Remove(GameObject.Find("player" + Lobby.infoRecvOnline.login[i]));
                        }

                        // comme a on supprime que ceux qui sont partis !
                        foreach (GameObject allie in allies)
                        {
                            Destroy(allie);
                        }

                        break;
                    }
            }
        }
    }

    // quand on ferme le jeu
    public void OnApplicationQuit()
    {
        try
        {
            // on ferme la websocket car elle se ferme pas toute seule en fait c'est nul
            Lobby.socket.CloseAsync();
        }
        catch { }
    }

    // l'envoi des donnes du joueur local au serveur (selon la frquence dfinit plus haut)
    public void SendDataToServer()
    {
        // on rcupre la scne actuelle
        Lobby.infoSendSimple.currentScene = SceneManager.GetActiveScene().name;

        // on se prpare  envoier ses points de vie ( modifier par une personne comptente)
        Lobby.infoSendSimple.hitPoint = Lobby.player.GetComponent<Players>().stats.currentHp.ToString();

        // on se prpare  envoier sa position et rotation
        Lobby.infoSendSimple.posX = Lobby.player.transform.position.x.ToString().Replace(".", ",");
        Lobby.infoSendSimple.posY = Lobby.player.transform.position.y.ToString().Replace(".", ",");
        Lobby.infoSendSimple.posZ = Lobby.player.transform.position.z.ToString().Replace(".", ",");
        Lobby.infoSendSimple.rotY = Lobby.player.transform.localEulerAngles.y.ToString().Replace(".", ",");

        // envoie des donnes au serveur qui les redonnera aux autres joueurs
        Lobby.socket.SendAsync(JsonConvert.SerializeObject(Lobby.infoSendSimple));

        // on enlve les animations qui ne doivent tre joues qu'une seule fois (peut-tre ?)
        // a me semble important mais je sais pas comment a marche
        Lobby.infoSendSimple.animAttack = "false";
        Lobby.infoSendSimple.animSpeAtt = "false";
        Lobby.infoSendSimple.animRoll = "false";
    }
}
