using UnityEngine;
using TMPro;
using UnityWebSocket;
using Newtonsoft.Json;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
using System.Collections.Generic;
using UnityEngine.InputSystem;

public class PlayerSelection : MonoBehaviour
{
    [SerializeField] private GameObject playerSelectionDisplay = default;
    [SerializeField] private GameObject mainDisplay = default;
    //[SerializeField] private Transform playerPrefabPreview = default;
    [SerializeField] private TMP_Text playerClassName = default;
    //[SerializeField] private float turnSpeed = 90f;
    [SerializeField] private Character[] characters = default;

    private int currentCharacterIndex = 0;
    //private List<GameObject> characterInstances = new List<GameObject>();

    public static GameObject currentPrefab;
    public static string currentPrefabName;
    //public static bool onSelectionDisplay = true;


    public void Start()
    {
        currentPrefab = characters[0].GameplayCharacterPrefab;
        currentPrefabName = characters[0].CharacterName;

        Lobby.InvokeCharacter();

        //if (playerPrefabPreview.childCount == 0)
        //{
        //    foreach (var character in characters)
        //    {
        //        GameObject characterInstance = Instantiate(character.CharacterPreviewPrefab, playerPrefabPreview);
        //        characterInstance.GetComponent<Rigidbody>().useGravity = false;
        //        characterInstance.GetComponent<PlayerCameraFocus>().enabled = false;

        //        characterInstance.SetActive(false);

        //        characterInstances.Add(characterInstance);
        //    }
        //}

        //characterInstances[currentCharacterIndex].SetActive(true);
        playerClassName.text = characters[currentCharacterIndex].CharacterName;

        playerSelectionDisplay.SetActive(true);  
    }

    private void Update()
    {
        //if (onSelectionDisplay)
        //{
        //    Lobby.player.GetComponent<PlayerController>().enabled = false;
        //    Lobby.player.GetComponent<PlayerInput>().enabled = false;
        //}
        //else
        //{
        //    Lobby.player.GetComponent<PlayerController>().enabled = true;
        //    Lobby.player.GetComponent<PlayerInput>().enabled = true;
        //}
    }

    public void Select()
    {
        //GameObject startPosition = GameObject.Find("Spawn" + Lobby.playerNumber);
        //Lobby.player = Instantiate(characters[currentCharacterIndex].GameplayCharacterPrefab, startPosition.transform.position, Quaternion.Euler(0, 0, 0));
        //Lobby.player.name = "player" + Lobby.login;

        playerSelectionDisplay.SetActive(false);
        mainDisplay.SetActive(true);

        //onSelectionDisplay = false;
    }

    public void Right()
    {
        //Debug.Log(currentCharacterIndex);
        //Debug.Log(characterInstances.Count);

        //characterInstances[currentCharacterIndex].SetActive(false);

        currentCharacterIndex = (currentCharacterIndex + 1) % characters.Length;

        //characterInstances[currentCharacterIndex].SetActive(true);
        playerClassName.text = characters[currentCharacterIndex].CharacterName;

        currentPrefab = characters[currentCharacterIndex].GameplayCharacterPrefab;
        currentPrefabName = characters[currentCharacterIndex].CharacterName;

        Lobby.InvokeCharacter();
    }

    public void Left()
    {
        //characterInstances[currentCharacterIndex].SetActive(false);

        currentCharacterIndex--;
        if(currentCharacterIndex < 0)
            currentCharacterIndex += characters.Length;

        //characterInstances[currentCharacterIndex].SetActive(true);
        playerClassName.text = characters[currentCharacterIndex].CharacterName;

        currentPrefab = characters[currentCharacterIndex].GameplayCharacterPrefab;
        currentPrefabName = characters[currentCharacterIndex].CharacterName;

        Lobby.InvokeCharacter();
    }
}