using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ArrowScript : MonoBehaviour
{
    public float life = 3f;
    public float attackDamage;
    public float power;
    public int damages;
    public LayerMask destructionCollision;

    public bool damageEnabled = true;

    //SFX
    public AudioSource audioSrc;
    public List<AudioClip> sfxHit;
    
    void Awake()
    {
        audioSrc.enabled = true;
        Destroy(gameObject, life);
    }
    
    
    void OnCollisionEnter(Collision col)
    {
        if (col.gameObject.layer == 6 || col.gameObject.layer == 8) // TODO
        {
            audioSrc.PlayOneShot(sfxHit[ScriptGenerationDonjon.randomPersonal.Next(0, sfxHit.Count)], 0.1f);
            Destroy(gameObject);
            OnTriggerEnter(col.gameObject.GetComponent<BoxCollider>());
        }
        
    }
    

    
    private void OnTriggerEnter(Collider other)
    {
        if (other is BoxCollider)
        {
            if (other.gameObject.layer == 6)
            {
                if (other.gameObject.GetComponent<Enemy>() == null)
                {
                    other.gameObject.GetComponentInParent<Enemy>().TakeDamage((damageEnabled ? damages : 0), (damageEnabled ? power : 0));
                }
                else
                {
                    other.gameObject.GetComponent<Enemy>().TakeDamage((damageEnabled ? damages : 0), (damageEnabled ? power : 0));
                }
                Destroy(gameObject);
            }
        }
    }
}

