using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class EndAnimation : MonoBehaviour
{
    // Ecran de fin
    private GameObject screen;


    void Start()
    {
        screen = GameObject.FindObjectOfType<Canvas>().transform.Find("EndScreen").gameObject;
    }
    public void EndUI()
    {
        // On désactive tous les enfants du Canvas
        for (int i = 0; i < GameObject.FindObjectOfType<Canvas>().transform.childCount; i++)
            GameObject.FindObjectOfType<Canvas>().transform.GetChild(i).gameObject.SetActive(false);

        StartCoroutine(FadeScreen());
    }

    // Déclanche l'animation de l'écran de fin
    public IEnumerator FadeScreen()
    {
        yield return new WaitForSeconds(1);

        // active l'écran de fin
        screen.gameObject.SetActive(true);

        // A chaque frame, on augmente petit à petit l'alpha de la couleur de l'écran
        for (float i = 0; i <= 1; i += Time.deltaTime)
        {
            screen.transform.GetComponent<Image>().color = new Color(0, 0, 0, i);
            yield return null;
        }

        // On fixe la valeur de l'alpha à 1 (= 255)
        // A la sortie de boucle, on est pas sûr que l'alpha soit bien à 1, donc on fixe la valeur manuellement
        screen.transform.GetComponent<Image>().color = new Color(0, 0, 0, 1);

        yield return new WaitForSeconds(1);

        StopCoroutine(FadeScreen());
        SceneManager.LoadScene("EndScene");
    }

}