using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class MainMenuScript : MonoBehaviour
{
    [Header("Les différentes scènes")]
    [SerializeField] GameObject mainMenu;
    [SerializeField] GameObject menuLogin;
    [SerializeField] GameObject menuLobby;


    [Header("Les boutons de la scène")]
    [SerializeField] Button buttonLogin;
    [SerializeField] Button buttonQuit;


    public void Start()
    {
        // Défini les actions des boutons
        buttonLogin.onClick.AddListener(GoToConnection);
        buttonQuit.onClick.AddListener(Application.Quit);
    }

    public void OnEnable()
    {
        if (PlayerInfo.GetConnection())
        {
            buttonLogin.GetComponentInChildren<TMP_Text>().text = "Jouer";
        }
        else
        {
            buttonLogin.GetComponentInChildren<TMP_Text>().text = "Connexion";
        }
    }

    public void GoToConnection()
    {
        if (PlayerInfo.GetConnection())
            GoFromMenuToMenu(mainMenu, menuLobby);

        else
            GoFromMenuToMenu(mainMenu, menuLogin);
    }

    private void GoFromMenuToMenu(GameObject menuA, GameObject menuB)
    {
        menuA.SetActive(false);
        menuB.SetActive(true);
    }
}