using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;

public class SecondAttackCooldown : MonoBehaviour
{
    [Header("Elements")]
    [SerializeField] private Image imageCooldown;
    [SerializeField] private TMP_Text textCooldown;
    private Players player;


    [Header("Variables")]
    // Temps de recharge de l'attaque secondaire
    [SerializeField] private float timer;

    // Booléen qui indique si l'attaque secondaire est utilisable ou non
    [SerializeField] private bool cooldownUsable;

    public void Init()
    {
        //DontDestroyOnLoad(gameObject);
        player = GameObject.Find("player" + Lobby.login).GetComponent<Players>();
        DefaultValueParameter();
    }

    // Défini les valeurs de bases des différents éléments
    public void DefaultValueParameter()
    {
        textCooldown.gameObject.SetActive(false);
        imageCooldown.fillAmount = 0.0f;

        cooldownUsable = true;
        timer = player.stats.secondAttackCd;
    }

    // Déclanche l'animation de cooldown
    public void StartCooldown()
    {
        if (cooldownUsable)
        {
            cooldownUsable = false;
            textCooldown.gameObject.SetActive(true);

            StartCoroutine(ApplyCooldown());
        }
    }

    // Animation du cooldown
    private IEnumerator ApplyCooldown()
    {
        while (timer > 0.0f)
        {
            // On soustrait au timer le temps parcouru entre 2 frames
            // Permet de ne pas dépendre de la puissance de calcul de la machine
            timer -= Time.deltaTime;

            // Affiche la valeur actuelle du timer (ramené à l'entier supérieur)
            textCooldown.text = Mathf.RoundToInt(timer + 1).ToString();

            // Permet de gérer l'animation d'horloge
            imageCooldown.fillAmount = timer / player.stats.secondAttackCd;
            yield return null;
        }

        // On redéfini les valeurs de bases
        DefaultValueParameter();

        StopCoroutine(ApplyCooldown());
    }
}