<?php
// Code source de vérification du format des champs envoyés
// par l'utilisateur.icem c'est à dire : 
// - la longueur doit se situer entre 3 et 50 caractères
// - les champs ne doivent pas contenir de 'whitespace' (e.g. un espace ou '\n')

function check_format($login, $password)
{
    $cred_min_size = 3;
    $cred_max_size = 50;
    $cli_login_len = strlen($login);
    $cli_passw_len = strlen($password);

    if (($cli_login_len < $cred_min_size) || ($cli_login_len > $cred_max_size)) {
        $errorMessage = 'Login is not the right size.';
        echo json_encode(array('isSuccessful' => 0, 'errorCode' => 110, 'errorMessage' => $errorMessage));
        exit(110);
    }

    if (($cli_passw_len < $cred_min_size) || ($cli_passw_len > $cred_max_size)) {
        $errorMessage = 'Password is not the right size.';
        echo json_encode(array('isSuccessful' => 0, 'errorCode' => 111, 'errorMessage' => $errorMessage));
        exit(111);
    }

    if (preg_match('/\s/', $login)) {
        $errorMessage = 'Login contains unsupported characters. Remove all whitespace characters.';
        echo json_encode(array('isSuccessful' => 0, 'errorCode' => 112, 'errorMessage' => $errorMessage));
        exit(112);
    }

    if (preg_match('/\s/', $password)) {
        $errorMessage = 'Password contains unsupported characters. Remove all whitespace characters.';
        echo json_encode(array('isSuccessful' => 0, 'errorCode' => 113, 'errorMessage' => $errorMessage));
        exit(113);
    }
}

?>